#!/bin/bash

export LC_TIME=en_US.UTF-8

PG_USER=psql  #postgres
PG_DUMPALL=/usr/local/bin/pg_dumpall 
PG_DUMP=/usr/local/bin/pg_dump
GZIP=/bin/gzip
BACKUP_DIR=/home/psql/backup/psql

function backup_pg_all {
	DOM=`date "+%a"`;
	BF1=psql-all-globals-$DOM.sql;
	BF2=psql-all-$DOM.sql;

	$PG_DUMPALL -U $PG_USER --globals-only >  $BACKUP_DIR/$BF1
	$PG_DUMPALL -U $PG_USER | gzip  > $BACKUP_DIR/$BF2.gz.tmp
	mv  $BACKUP_DIR/$BF2.gz.tmp $BACKUP_DIR/$BF2.gz
} 



function backup_pg {
	DB=$1;
	DOM=`date "+%d"`;
	BF=psql-$DB-$DOM.pgdump;

	$PG_DUMP -U $PG_USER -Fc $DB > $BACKUP_DIR/$BF.tmp
	mv $BACKUP_DIR/$BF.tmp $BACKUP_DIR/$BF
} 



backup_pg psql;

backup_pg_all;

