

CREATE OR REPLACE FUNCTION sale(
arg_customer integer, 
arg_order_no integer, 
arg_magazine integer, 
arg_quantity integer, 
arg_price numeric
)  RETURNS integer AS $$
DECLARE
	rec record;
	p_price numeric;
	p_id integer;
	p_amount numeric;
	p_dif numeric;
	
BEGIN

	if arg_price < 0 then
		raise EXCEPTION 'money (%) < 0 ', arg_money;
	end if; 

	SELECT into rec 1 FROM customer WHERE id = arg_customer;
	if not found then
		raise EXCEPTION 'Customer Not Found % ', arg_customer;
	end if;

	SELECT into rec 1 FROM sale WHERE order_no = arg_order_no AND customer = arg_customer AND magazine = arg_magazine;
	if found then
		raise EXCEPTION 'sale allredy exist FOR (order_no,customer,magazine) : (%, %, %)',arg_order_no, arg_customer, arg_magazine;
	end if; 

	--prosoxi: to parakato select den e3asfalizi oti to ipolipo 8a ine eparkes.
	SELECT into rec price FROM magazine WHERE id = arg_magazine AND quantity >= arg_quantity;
	if not found then
		raise EXCEPTION 'Magazine with proper quantity Not Found (magazine,quantity) : (%,%)',arg_magazine, arg_quantity;
	end if;    
	
	p_price := rec.price;
	p_dif := arg_price - p_price;
	if p_dif > 0 then
		raise EXCEPTION 'sale price > magazine price';
	end if;

	if p_dif < p_price/2 then
		raise WARNING 'big sale discount';
	end if;

	p_amount := arg_price * arg_quantity;
	
	UPDATE magazine SET quantity = (quantity - arg_quantity) WHERE id = arg_magazine;
	p_id := nextval('sale_id_seq');

	INSERT INTO sale (id,order_no,customer,magazine,quantity,org_price,sales_amount,sales_dt) VALUES	
	(p_id, arg_order_no, arg_customer, arg_magazine, arg_quantity, p_price, p_amount, now());
	
        return p_id;
        
END
$$ LANGUAGE plpgsql;








--SELECT sale(1,12, 1,12,8.20);


