-------------------------
--TRIGERS
------------------------
CREATE OR REPLACE FUNCTION sale_after_insert_trigger_f() RETURNS trigger AS $$
DECLARE
BEGIN
	
	INSERT INTO sales_registry (id, transaction_date, amount,description) 
	VALUES (default,NEW.sales_dt, NEW.sales_amount, 'sale: '||NEW.id);
	
RETURN NEW;
	   
END
$$ LANGUAGE plpgsql;



DROP TRIGGER  sale_after_insert_trigger ON sale;

CREATE TRIGGER sale_after_insert_trigger AFTER INSERT ON sale
FOR EACH ROW EXECUTE PROCEDURE sale_after_insert_trigger_f();



-----------------------------
--
-----------------------------
CREATE OR REPLACE FUNCTION sale_before_update_trigger_f() RETURNS trigger AS $$
DECLARE
BEGIN
	
	RAISE EXCEPTION 'NOT PERMITED';

RETURN OLD; -- epistrefei tin palia version (den kanei update)	
	   
END
$$ LANGUAGE plpgsql;



DROP TRIGGER  sale_before_update_trigger ON sale;

CREATE TRIGGER sale_before_update_trigger BEFORE UPDATE ON sale
FOR EACH ROW EXECUTE PROCEDURE sale_before_update_trigger_f();

